﻿//WRITTEN BY GAMEPILL.COM
//CONTROLS ALL GAME PIECES
class GameController extends Game{
	
	
	//************************************************************
	//PRIVATE VARS
	//************************************************************
	private var GameBoardMC:MovieClip;
	private var InitialAni:MovieClip;
	private var QuestionsMC:MovieClip;
	private var ShadeMC:MovieClip;
	private var IntroComputerAniMC:MovieClip;
	private var LooseAniMC:MovieClip;
	private var WinAniMC:MovieClip;
	private var FinalScreenMC:MovieClip;
	
	private var playerLoosesSound:Sound;
	
	
	
	//************************************************************
	//PROPERTIES
	//************************************************************
	
	
	
	

	//************************************************************
	//CONSTRUCTOR FUNCTIONS
	//************************************************************

	//NOTE GAME WIREUP IS PERFORMED BY THE InitialAni ON ITS FRAME 2 AS
	//IT CALLES --- initiateGameWireUp() FUNCTION
	public function GameController(){
		
		trace("GameController Created");
		
		//this is necessary for the zargo tweening extensions
		//note to use tweening in subclasses you must override the MovieClip.as and the TextField.as files
		//with Zargo files. Place them in the class path
		//http://laco.wz.cz/tween/examples.htm
		//http://laco.wz.cz/forum/viewtopic.php?t=282
		with (_root) {
			#include "lmc_tween.as"
		} 
		
		setupInitialVisuals();
		
		playerLoosesSound = new Sound(this);
		playerLoosesSound.attachSound("p2p_lose.wav");
		
		
	}
	
	
	
	//************************************************************
	//VISUAL FUNCTIONS
	//************************************************************
	private function setupInitialVisuals(){
		
		//ShadeMC._visible = false;
		
	}
	
	
	//************************************************************
	//INITIAL FUNCTIONS
	//************************************************************
	
	//call on super
	//setup all the events this mc will handle
	private function setupEventListeners(){
		
		var listenFor1:Object = {MC:QuestionsMC, EVT:"clickToContinue"}
		var listenFor2:Object = {MC:InitialAni, EVT:"clickToPlay"}
		var listenFor3:Object = {MC:GameBoardMC, EVT:"squarePlacedOnBoard"}
		var listenFor4:Object = {MC:IntroComputerAniMC, EVT:"introComputerFinished"}
		var listenFor5:Object = {MC:LooseAniMC, EVT:"finalAniFinished"}
		var listenFor6:Object = {MC:WinAniMC, EVT:"finalAniFinished"}
		registerListenerGCAsListenerFor([listenFor1, listenFor2, listenFor3, listenFor4, listenFor5, listenFor6]);
		
	}
	
	
	
	//************************************************************
	//PUBLIC GENERAL FUNCTIONS
	//************************************************************
	
	
	
	
	//************************************************************
	//PRIVATE GENERAL FUNCTIONS
	//************************************************************
	
	private function allowTheUserToHaveATurn(){
		
		//setPromptToUserTurn()
		GameBoardMC.allowUserMove();
		
	}
	
	
	private function allowTheComputerToHaveATurn(){
		
		//the slider is sliding,
		//when it is finished randomly pick squares then choose
		GameBoardMC.setPromptToComputerTurn();
		
		//ask gameboard to flash squares then it will call computer move.
		
		
		GameBoardMC.makeComputerMove();
		
	}
	
	
	
	private function userLooses(){
		
		
			//play the loosing ani then the final score screen
			GameBoardMC.disableGameBoardMC();
			QuestionsMC.disableTFButtons();
			LooseAniMC.gotoAndPlay(2);
			LooseAniMC.showGamePieceTween();
			
	}
	
	private function userWins(){
		
			//play the winning ani then the final score screen
			GameBoardMC.disableGameBoardMC();
			QuestionsMC.disableTFButtons();
			WinAniMC.gotoAndPlay(2);
			WinAniMC.showGamePieceTween();
		
	}
	
	private function nextQuestion(){
		
		//GameBoardMC.makeComputerMove();
		ShadeMC.gotoAndPlay("slideLeft");
		QuestionsMC.poseQuestion();
		
	}
	

	
	
	
	//************************************************************
	//REGULAR EVENT FUNCTIONS
	//************************************************************
	
	//ESSENTIAL SETUP FUNCTION ------ READ WHY BELOW
	//this is the function that is called on frame 2 of the introduction animation
	//It sets up event listeners and anything else necessary after frame 1 has started playing
	private function initiateGameWireUp(){
		
		setupEventListeners();
		
		LooseAniMC.hideGamePiece();
		WinAniMC.hideGamePiece();
		FinalScreenMC.hideGamePiece();
		GameBoardMC.disableGameBoardMC();
		QuestionsMC.disableTFButtons();
		
	}
	
	
	private function computerMove(){
		
		GameBoardMC.makeComputerMove();
		
	}
	
	
	//************************************************************
	//CUSTOM EVENT FUNCTIONS
	//************************************************************
	
	public function clickToPlay(evt:Object):Void {
		
		
		
		//trace("EVENT CAUGHT BY CONTROLLER = " + evt.target);
		//trace("MESSAGE = " + evt.messageObject.myMessage);
		
		
		/*GameBoardMC.showGamePiece();
		GameBoardMC.initGame();
		GameBoardMC.disableGameBoardMC();
		
		QuestionsMC.restartQuestions();
		QuestionsMC.poseQuestion();
		
		InitialAni.b_clickToPlay.enabled = false;
		InitialAni.hideGamePieceTween();*/
		InitialAni.b_clickToPlay._visible = false;
		InitialAni.hideGamePieceTween();
		
		IntroComputerAniMC.gotoAndPlay("play");
		
	}
	
	
	
	public function introComputerFinished(evt:Object):Void {
		
		trace("dispatching intro egvent startingh game");
		IntroComputerAniMC.b_clickToPlay.enabled = false;
		IntroComputerAniMC.hideGamePieceTween();
		
		
		GameBoardMC.showGamePiece();
		GameBoardMC.initGame();
		GameBoardMC.disableGameBoardMC();
		
		QuestionsMC.restartQuestions();
		QuestionsMC.poseQuestion();
		
	
		
	}
	
	
	
	
	
	 public function clickToContinue(evt:Object):Void {
		
		//trace("EVENT CAUGHT BY CONTROLLER = " + evt.target);
		//trace("MESSAGE = " + evt.messageObject.myMessage);
		
		if(evt.messageObject.myMessage == "userMove"){
			
			allowTheUserToHaveATurn();
			
			
		}else if(evt.messageObject.myMessage == "computerMove"){
			
			allowTheComputerToHaveATurn();
			
		}
		
		//trace("play shade");
		ShadeMC.gotoAndPlay("slideRight");
		
	}
	
	
	
	//decide on the next course of action depending on what happened with the last move made
	public function squarePlacedOnBoard(evt:Object):Void {
		
		trace("squarePlacedOnBoard = " + evt.messageObject.myMessage);
		if(evt.messageObject.myMessage == "UserLooses"){
			
			var pauseCodeExec:Function = function(thisMC){
					thisMC.playerLoosesSound.start();
					thisMC.userLooses();
			}
			pauseCodeAndCallFunction(2000, pauseCodeExec);
			
			//playerLoosesSound.start();
			//userLooses();
			
		}
		
		
		if(evt.messageObject.myMessage == "UserWins"){
			
			var pauseCodeExec:Function = function(thisMC){
					thisMC.GameBoardMC.playerWinsSound.start();
					thisMC.userWins();
			}
			pauseCodeAndCallFunction(2000, pauseCodeExec);
			//GameBoardMC.playerWinsSound.start();
			//userWins();
			
		}
		
		
		if(evt.messageObject.myMessage == "NextQuestion"){
			
			var pauseCodeExec:Function = function(thisMC){
					thisMC.nextQuestion();
			}
			pauseCodeAndCallFunction(2000, pauseCodeExec);
			//nextQuestion();
			
		}
	}
	
	
	//goto and play final screen
	private function finalAniFinished(evt:Object):Void {
		
		trace("final ani finsied event");
		FinalScreenMC.showGamePiece();
		
		if(evt.messageObject.myMessage == "UserLooses"){
			trace("user lost");
			LooseAniMC.hideGamePieceTween();
			
		}else{
			
			WinAniMC.hideGamePieceTween();
			
		}
		
		
		
	}
	
	
	
	
	
	
}